diff --git a/arch/arm/configs/Kconfig.imx51 b/arch/arm/configs/Kconfig.imx51
index 512c9d5..5f6e50e 100644
--- a/arch/arm/configs/Kconfig.imx51
+++ b/arch/arm/configs/Kconfig.imx51
@@ -11,6 +11,9 @@ config generateconfig_MX51_YES
 	select VFP
 	select NEON
 
+	select MACH_MX53_EVK
+	select MACH_MX53_SMD
+	select MACH_MX53_LOCO
 
 	select NET
 	select NET_ETHERNET
@@ -59,7 +62,6 @@ config generateconfig_MX51_YES
 	select RTC_DRV_M41T80_WDT
 	select RTC_DRV_TWL4030
 	select RTC_INTF_DEV_UIE_EMUL
-	select RTC_DRV_M41T80
 
 
 config MXC_DEBUG_BOARD
@@ -69,14 +71,431 @@ config DEFAULT_MMAP_MIN_ADDR
 	default 32768
 config LOG_BUF_SHIFT
 	default 18
-
+config CMDLINE
+	default "noinitrd console=ttymxc0,115200 root=/dev/nfs nfsroot=192.168.0.101:/shared/nfs ip=dhcp"
 config MII
 	default m
 config LEDS_LP5521
 	default m
 config LEDS_LP5523
 	default m
+config RTC_DRV_M41T80
+	default m
+
+
+# The following should be Kconfig.distro policy
+config generateconfig_SHOULD_BE_DISTROCONF_YES
+	def_bool y
+	select CC_OPTIMIZE_FOR_SIZE
+	select EMBEDDED
+	select RELAY
+	select MODVERSIONS
+	select MODULE_SRCVERSION_ALL
+
+	select KALLSYMS_ALL
+	select PREEMPT_VOLUNTARY
+
+	select TICK_ONESHOT
+	select NO_HZ
+	select HIGH_RES_TIMERS
+
+	select RD_BZIP2
+	select RD_LZMA
+	select RD_LZO
+
+	select PM
+	select PM_RUNTIME
+        select PM_SLEEP
+        select SUSPEND
+        select SUSPEND_FREEZER
+        select PM_OPS
+
+	select PM_DEBUG
+	select PM_TEST_SUSPEND
+
+	select USB_SUSPEND
+
+
+	select IP_PNP
+	select IP_PNP_DHCP
+	select IP_PNP_BOOTP
+
+	select DNS_RESOLVER
+
+
+	select CONNECTOR
+	select PROC_EVENTS
+
+	select BLK_DEV_LOOP
+
+	select HW_RANDOM
+
+
+	select I2C
+	select GPIOLIB
+
+	select MFD_TC6393XB
+	select MFD_ASIC3
+	select HTC_I2CPLD
+	select HTC_EGPIO
+	select MFD_88PM860X
+	select MFD_TMIO
+	select MFD_T7L66XB
+	select MFD_TC6387XB
+	select PMIC_DA903X
+	select PMIC_ADP5520
+	select MFD_MAX8925
+	select MFD_WM8350_I2C
+	select MFD_WM8994
+	select ABX500_CORE
+	select AB3100_CORE
+	select AB3550_CORE
+
+
+
+	select MDIO_GPIO
+	select MDIO_BITBANG
+
+	select MTD_PARTITIONS
+
+	select MMC_SDHCI
+
+	select SCSI_MULTI_LUN
+	select SCSI_CONSTANTS
+	select SCSI_LOGGING
+	select SCSI_SCAN_ASYNC
+
+	select MARVELL_PHY
+	select DAVICOM_PHY
+	select QSEMI_PHY
+	select LXT_PHY
+	select CICADA_PHY
+	select VITESSE_PHY
+	select SMSC_PHY
+	select BROADCOM_PHY
+	select ICPLUS_PHY
+	select REALTEK_PHY
+	select NATIONAL_PHY
+	select STE10XP
+	select LSI_ET1011C_PHY
+
+	select MOUSE_PS2_ELANTECH
+
+
+	select NEW_LEDS
+	select LEDS_CLASS
+	select LEDS_TRIGGERS
+
+	select EXT2_FS_XATTR
+	select EXT2_FS_POSIX_ACL
+	select EXT2_FS_SECURITY
+
+	select EXT3_DEFAULTS_TO_ORDERED
+	select EXT3_FS_XATTR
+	select EXT3_FS_POSIX_ACL
+	select EXT3_FS_SECURITY
+
+	select EXT4_FS_XATTR
+	select EXT4_FS_POSIX_ACL
+	select EXT4_FS_SECURITY
+
+	select AUTOFS4_FS
+	select FAT_FS
+	select VFAT_FS
+
+	select GFS2_FS_LOCKING_DLM
+
+
+	select QUOTA
+	select QUOTA_NETLINK_INTERFACE
+	select QUOTACTL
+	select FUSE_FS
+	select UDF_NLS
+
+	select DEBUG_FS
+	select ECRYPT_FS
+
+	select NFS_V3_ACL
+	select NFS_V4
+
+	select NLS_CODEPAGE_437
+	select NLS_ASCII
+	select NLS_UTF8
+
+	select SCHEDSTATS
+	select EARLY_PRINTK
+
+	select ENABLE_WARN_DEPRECATED
+	select ENABLE_MUST_CHECK
+	select DEBUG_MEMORY_INIT
 
+	select KEYS
+
+	select CRYPTO_DES
+	select CRYPTO_DEFLATE
+	select CRYPTO_LZO
+
+	select CRC_T10DIF
+
+config UTS_NS
+	default n
+config IPC_NS
+	default n
+config USER_NS
+	default n
+config PID_NS
+	default n
+config NET_NS
+	default n
+config SLUB_DEBUG
+	default n
+config LBDAF
+	default n
+config OABI_COMPAT
+	default n
+config IP_SCTP
+	default n
+config WIRELESS
+	default n
+config NETDEV_1000
+	default n
+config NETDEV_10000
+	default n
+config WLAN
+	default n
+config LEGACY_PTYS
+	default n
+config INET_XFRM_MODE_TRANSPORT
+	default n
+config INET_XFRM_MODE_TUNNEL
+	default n
+config INET_XFRM_MODE_BEET
+	default n
+config INET_LRO
+	default n
+config SCSI_LOWLEVEL
+	default n
+config HWMON
+	default n
+config STANDALONE
+	default n
+config INPUT_MOUSEDEV_PSAUX
+	default n
+config I2C_COMPAT
+	default n
+config PRINT_QUOTA_WARNING
+	default n
+config FTRACE
+	default n
+config ARM_UNWIND
+	default n
+config DEBUG_BUGVERBOSE
+	default n
+config CRYPTO_ANSI_CPRNG
+	default n
+config CRYPTO_HW
+	default n
+config BINARY_PRINTF
+	default n
+
+
+config BINFMT_MISC
+	default m
+config INET6_XFRM_MODE_TRANSPORT
+	default m
+config INET6_XFRM_MODE_TUNNEL
+	default m
+config INET6_XFRM_MODE_BEET
+	default m
+config ATA
+	default m
+config CRYPTO_AES
+	default m
+config INPUT_FF_MEMLESS
+	default m
+config INPUT_POLLDEV
+	default m
+config INPUT_EVBUG
+	default m
+config MTD_CFI_STAA
+	default m
+config SERIO_SERPORT
+	default m
+config I2C_CHARDEV
+	default m
+config I2C_SMBUS
+	default m
+config I2C_ALGOBIT
+	default m
+config I2C_ALGOPCF
+	default m
+config I2C_ALGOPCA
+	default m
+config I2C_DESIGNWARE
+	default m
+config I2C_GPIO
+	default m
+config I2C_OCORES
+	default m
+config I2C_PCA_PLATFORM
+	default m
+config I2C_SIMTEC
+	default m
+config I2C_XILINX
+	default m
+config I2C_PARPORT
+	default m
+config I2C_PARPORT_LIGHT
+	default m
+config I2C_TAOS_EVM
+	default m
+config I2C_TINY_USB
+	default m
+config I2C_STUB
+	default m
+config FB_TMIO
+	default m
+config FB_SM501
+	default m
+config USB_UAS
+	default m
+config GFS2_FS
+	default m
+config AUTOFS4_FS
+	default m
+config CONFIGFS_FS
+	default m
+config UDF_FS
+	default m
+config SUNRPC_GSS
+	default m
+config RPCSEC_GSS_KRB5
+	default m
+config LEDS_88PM860X
+	default m
+config LEDS_PCA9532
+	default m
+config LEDS_PCA955X
+	default m
+config LEDS_LP3944
+	default m
+config LEDS_WM8350
+	default m
+config LEDS_DA903X
+	default m
+config LEDS_BD2802
+	default m
+config LEDS_ADP5520
+	default m
+config SND_RAWMIDI
+	default m
+config SND_DUMMY
+	default m
+config SND_MTS64
+	default m
+config SND_MPU401
+	default m
+config SND_PORTMAN2X4
+	default m
+
+config MFD_SM501
+	default m
+config HTC_PASIC3
+	default m
+config TPS6507X
+	default m
+config MFD_WM8400
+	default m
+config MFD_PCF50633
+	default m
+config PCF50633_ADC
+	default m
+config PCF50633_GPIO
+	default m
+
+config RTC_DRV_DS1307
+	default m
+config RTC_DRV_DS1374
+	default m
+config RTC_DRV_DS1672
+	default m
+config RTC_DRV_MAX6900
+	default m
+config RTC_DRV_MAX8925
+	default m
+config RTC_DRV_RS5C372
+	default m
+config RTC_DRV_ISL1208
+	default m
+config RTC_DRV_X1205
+	default m
+config RTC_DRV_PCF8563
+	default m
+config RTC_DRV_PCF8583
+	default m
+config RTC_DRV_M41T80
+	default m
+config RTC_DRV_BQ32K
+	default m
+config RTC_DRV_S35390A
+	default m
+config RTC_DRV_FM3130
+	default m
+config RTC_DRV_RX8581
+	default m
+config RTC_DRV_RX8025
+	default m
+config RTC_DRV_M41T94
+	default m
+config RTC_DRV_DS1305
+	default m
+config RTC_DRV_DS1390
+	default m
+config RTC_DRV_MAX6902
+	default m
+config RTC_DRV_R9701
+	default m
+config RTC_DRV_RS5C348
+	default m
+config RTC_DRV_DS3234
+	default m
+config RTC_DRV_PCF2123
+	default m
+config RTC_DRV_WM8350
+	default m
+config RTC_DRV_PCF50633
+	default m
+config RTC_DRV_AB3100
+	default m
+config RTC_DRV_PCAP
+	default m
+
+config HW_RANDOM_TIMERIOMEM
+	default m
+
+config KEYBOARD_ADP5588
+	default m
+config KEYBOARD_TCA6416
+	default m
+config KEYBOARD_LM8323
+	default m
+config KEYBOARD_MAX7359
+	default m
+
+config MOUSE_SYNAPTICS_I2C
+	default m
+config INPUT_AD714X_I2C
+	default m
+config INPUT_PCF8574
+	default m
+
+config I2C_SI4713
+	default m
+config I2C_SI470X
+	default m
+
+config NLS_ISO8859_15
+	default m
 
 
 source "Kconfig.distro"